#include "hazy_sgd.h"

class Hazy_Sgd_Wrapper {
 protected:
  bool is_dense;
  
 public:
  bool is_sgd_dense() {return is_dense;}
};

class Hazy_Sgd_FVector : public Hazy_Sgd_Wrapper {
  Hazy_Sgd<FVector> *sgd;

 public:
  Hazy_Sgd_FVector(Hazy_Sgd<FVector> *_sgd) {
    this->is_dense = true;
    sgd = _sgd;
  }

  Hazy_Sgd<FVector>* get_Hazy_Sgd() {return sgd;}
};

class Hazy_Sgd_SVector : public Hazy_Sgd_Wrapper {
  Hazy_Sgd<SVector> *sgd;

 public:
  Hazy_Sgd_SVector(Hazy_Sgd<SVector> *_sgd) {
    this->is_dense = false;
    sgd = _sgd;
  }

  Hazy_Sgd<SVector>* get_Hazy_Sgd() {return sgd;}
};
