--get Features
--$1: view id
--$2: entity table name
CREATE OR REPLACE FUNCTION getFeatures(integer) RETURNS VOID AS $$
DECLARE
      m_factor integer;
BEGIN
    EXECUTE 'DROP TABLE IF EXISTS extractedFeatures' || CAST($1 AS TEXT) || ';';
    EXECUTE 'CREATE TABLE extractedFeatures' || CAST($1 AS TEXT) || ' AS (SELECT id, temp2' || CAST($1 AS TEXT) || '.word AS FEATURE, (temp2' || CAST($1 AS TEXT) || '.tf * extractedStats' || CAST($1 AS TEXT) || '.idf) AS FEATURE_VALUE FROM (SELECT id, (intermediateStats' || CAST($1 AS TEXT) || '.auxF).wordf AS word, (intermediateStats' || CAST($1 AS TEXT) || '.auxF).tff AS tf FROM intermediateStats' || CAST($1 AS TEXT) || ') AS temp2' || CAST($1 AS TEXT) || ', extractedStats' || CAST($1 AS TEXT) || ' where temp2' || CAST($1 AS TEXT) || '.word = extractedStats' || CAST($1 AS TEXT) || '.word order by id);';
    EXECUTE 'DROP TABLE IF EXISTS extractedStats' || CAST($1 AS TEXT) || ';' ;
    EXECUTE 'DROP TABLE IF EXISTS intermediateStats' || CAST($1 AS TEXT) || ';';
END;
$$ LANGUAGE plpgsql;
