--$1: view id
CREATE OR REPLACE FUNCTION normalizeGetM_Factor(integer) RETURNS FLOAT8 AS $$
DECLARE
	m_factorrec RECORD;
	m_factor FLOAT8;
BEGIN
    EXECUTE 'UPDATE extractedFeatures' || CAST($1 AS TEXT) || ' SET feature_value = feature_value / sum FROM (SELECT id, sum(feature_value) FROM extractedFeatures' || CAST($1 AS TEXT) || ' GROUP BY id) AS norm_temp' || CAST($1 AS TEXT) || ' WHERE norm_temp' || CAST($1 AS TEXT) || '.id = extractedFeatures' || CAST($1 AS TEXT) || '.id;'; 
    FOR m_factorrec in EXECUTE 'SELECT max(sum) FROM (SELECT sum(abs(feature_value)) from extractedFeatures' || CAST($1 AS TEXT) || ' GROUP BY id order by id) as norm_one' || CAST($1 AS TEXT) || ';'
    LOOP
        m_factor := m_factorrec.max;
    END LOOP;
EXECUTE 'DROP INDEX IF EXISTS exf' || CAST($1 AS TEXT) || ';';
EXECUTE 'CREATE INDEX exf' || CAST($1 AS TEXT) || ' ON extractedFeatures' || CAST($1 AS TEXT) || '(id, feature);';	
    RETURN m_factor;
END;
$$ LANGUAGE plpgsql;
