--$1: view id
--$2: example table name
--$3: example table id col name
--$4: example table label col name
CREATE OR REPLACE FUNCTION prepare_train(integer, text, text, text) RETURNS VOID AS $$
BEGIN
    EXECUTE 'DROP TABLE IF EXISTS TRAINING' || CAST($1 AS TEXT) || ';';
		EXECUTE 'CREATE TABLE training' || CAST($1 AS TEXT) || ' AS (SELECT ' || $3 || ' as id, ' || $4 || ' as label, ' || 'feature_vector' || ' FROM ' || $2 || ');';
END;
$$ LANGUAGE plpgsql;

--$1: view id
CREATE OR REPLACE FUNCTION create_entity_features(integer) RETURNS VOID AS $$
BEGIN
		EXECUTE 'DROP TABLE IF EXISTS entity_features_temp' || CAST($1 AS TEXT) || ';';
		EXECUTE 'DROP TABLE IF EXISTS hazy_entity_table' || CAST($1 AS TEXT) || ';';
		EXECUTE 'DROP SEQUENCE IF EXISTS serial' || CAST($1 AS TEXT) || ';';
    EXECUTE 'DROP TABLE IF EXISTS featureIds' || CAST($1 AS TEXT) || ';';
    EXECUTE 'DROP INDEX IF EXISTS fids' || CAST($1 AS TEXT) || ';';
		EXECUTE 'CREATE TEMP SEQUENCE serial' || CAST($1 AS TEXT) || ' START 1;';
    EXECUTE 'CREATE TABLE featureIds' || CAST($1 AS TEXT) || '(feature_id int, feature text);';
    EXECUTE 'INSERT INTO featureIds' || CAST($1 AS TEXT) || '(SELECT nextval(''serial' || CAST($1 AS TEXT) || ''') as feature_id, feature FROM (SELECT distinct(feature) FROM extractedFeatures' || CAST($1 AS TEXT) || ' ORDER BY feature) AS TEMP1' || CAST($1 AS TEXT) || ');';
    EXECUTE 'CREATE INDEX fids' || CAST($1 AS TEXT) || ' ON featureids' || CAST($1 AS TEXT) || '(feature,feature_id);';
		EXECUTE 'CREATE TABLE entity_features_temp' || CAST($1 AS TEXT) || ' AS (SELECT ' || ' id, feature_id, feature_value, ' || ' (''"('' || feature_id || '','' || feature_value || '')"'')::text as vec_rep FROM featureIds' || CAST($1 AS TEXT) || ' , extractedFeatures' || CAST($1 AS TEXT) || ' WHERE' || ' featureids' || CAST($1 AS TEXT) || '.feature = extractedfeatures' || CAST($1 AS TEXT) || '.feature ORDER BY id, feature_id);';
		EXECUTE 'CREATE TABLE hazy_entity_table' || CAST($1 AS TEXT) || ' AS (SELECT id, (''{'' || group_concat(vec_rep) || ''}'')::pair[] AS feature_vector FROM entity_features_temp' || CAST($1 AS TEXT) || ' GROUP BY id);';
END;
$$ LANGUAGE plpgsql;
