(* File hazy_lexer.mll *)
{
open Parser
exception Eof
}

rule rs = parse
     [' ' '\t' '\n']				{ rs lexbuf}	(* skip blanks *)
|    "--"[^'\n']*'\n'				{ rs lexbuf }
|    ';'	   				{ EOL }
|    ['0'-'9']+ as lxm			{ INT(int_of_string(lxm)) } 
|    ['c''C']['r''R']['e''E']['a''A']['t''T']['e''E']				{ CREATE }
|    ['c''C']['l''L']['a''A']['s''S']['s''S']['i''I']['f''F']['i''I']['c''C']['a''A']['t''T']['i''I']['o''O']['n''N']			{ CLASSIFICATION }
|    ['v''V']['i''I']['e''E']['w''W']													{ VIEW }
|    ['k''K']['e''E']['y''Y']														{ KEY }
|    ['e''E']['n''N']['t''T']['i''I']['t''T']['i''I']['e''E']['s''S']
     { ENTITIES }
|    ['f''F']['r''R']['o''O']['m''M']
     { FROM }
|    ['l''L']['a''A']['b''B']['e''E']['l''L']['s''S']
     { LABELS }
|    ['l''L']['a''A']['b''B']['e''E']['l''L']
     { LABEL }
|    ['e''E']['x''X']['a''A']['m''M']['p''P']['l''L']['e''E']['s''S']
     { EXAMPLES }
|    ['f''F']['e''E']['a''A']['t''T']['u''U']['r''R']['e''E']
     { FEATURE }
|    ['f''F']['u''U']['n''N']['c''C']['t''T']['i''I']['o''O']['n''N']
     { FUNCTION }
|    ['A'-'Z''a'-'z''_']['A'-'Z''a'-'z''0'-'9''_']*				{ STRING(Lexing.lexeme lexbuf) } 
|    eof				{ raise Eof }
     
