#include <stdio.h>
#include <caml/mlvalues.h>
#include <caml/memory.h>
#include "parse_conf_file.h"
#include "globals.h"

CAMLprim value
call_create_view_fnc( value ml_tuple )
{
    char *view_name           = String_val(Field(ml_tuple,0));
    char *view_key            = String_val(Field(ml_tuple,1));
    char *entity_table        = String_val(Field(ml_tuple,2));
    char *entity_table_key    = String_val(Field(ml_tuple,3));
    char *labels_table        = String_val(Field(ml_tuple,4));
    char *label_in_table      = String_val(Field(ml_tuple,5));
    char *example_table       = String_val(Field(ml_tuple,6));
    char *example_table_key   = String_val(Field(ml_tuple,7));
    char *example_table_label = String_val(Field(ml_tuple,8));
    char *feature_function    = String_val(Field(ml_tuple,9));

    char *hazy_dirs_path = retrieve_hazy_dirs_path();
    char *system_command = malloc(sizeof(char) * (strlen(hazy_dirs_path) + strlen(view_name) 
						  + strlen(view_key) + strlen(entity_table) 
						  + strlen(entity_table_key) + strlen(labels_table)
						  + strlen(label_in_table) + strlen(example_table)
						  + strlen(example_table_key) + strlen(example_table_label)
						  + strlen(feature_function) + strlen(CREATE_VIEW_EXEC) + 100));

    strcpy(system_command, hazy_dirs_path);
    strcat(system_command, "/");
    strcat(system_command, CREATE_VIEW_EXEC);
    strcat(system_command, " ");
    strcat(system_command, view_name);
    strcat(system_command, " ");
    strcat(system_command, view_key);
    strcat(system_command, " ");
    strcat(system_command, entity_table);
    strcat(system_command, " ");
    strcat(system_command, entity_table_key);
    strcat(system_command, " ");
    strcat(system_command, labels_table);
    strcat(system_command, " ");
    strcat(system_command, label_in_table);
    strcat(system_command, " ");
    strcat(system_command, example_table);
    strcat(system_command, " ");
    strcat(system_command, example_table_key);
    strcat(system_command, " ");
    strcat(system_command, example_table_label);
    strcat(system_command, " ");
    strcat(system_command, feature_function);

    system(system_command);

    free(hazy_dirs_path);
    free(system_command);

    return Val_unit;
}
