#include <sys/time.h>
#include <fstream>
#include <stdio.h>
#include "libpq-fe.h"
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <map>
#include <vector>
#include <cassert>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <iterator>

using namespace std;


void
exit_nicely(PGconn *conn)
{
  PQfinish(conn);
  return;
}


int main(int argc, char** argv) {
	string conninfo;
  string query; 
	string line = "";
	ifstream myfile (argv[2]);
	ofstream wrfile (argv[3]);

  PGresult *res;
	PGconn *conn;
  
	string db = argv[1];
  conninfo = "dbname = " + db;
  conn = PQconnectdb(conninfo.c_str());

	if (PQstatus(conn) == CONNECTION_BAD)
  {
    fprintf(stderr, "Connection to database '%s' failed.\n", db.c_str());
    fprintf(stderr, "%s", PQerrorMessage(conn));
  } 

	int server_id_from_query = -1;
	string prepared_file_name = argv[4];
	int numOfInput = atoi(argv[5]);
	int numOfParameters = atoi(argv[6]);
	int server_id = atoi(argv[7]);
	int parallel = atoi(argv[8]);


/*	while(server_id_from_query != server_id) {
		res = PQexec(conn, "SELECT getServerId();");
		server_id_from_query = atoi(PQgetvalue(res, 0, 0));
		sleep(5);
		PQclear(res);
	}*/

	cerr << "it seems server started" << endl;

/*	res = PQexec(conn, "SELECT COUNT(*) FROM internal_table; SELECT COUNT(*) FROM internal_table WHERE id = 5; SELECT COUNT(*) FROM internal_table WHERE c > 1; SELECT COUNT(*) FROM internal_table WHERE C > 2;");
	PQclear(res);
	res = PQexec(conn, "SELECT COUNT(*) FROM externel_table; SELECT class FROM externel_table WHERE id = 25;");
	PQclear(res);
	res = PQexec(conn, "SELECT COUNT(*) FROM externel_table; SELECT COUNT(*) FROM externel_table WHERE c > 1; SELECT COUNT(*) FROM externel_table WHERE c > 2;");
	PQclear(res);	*/


	ifstream preparefile(prepared_file_name.c_str());
	if(preparefile.is_open()) {
		while(!preparefile.eof() && getline(preparefile, line)) {
 			res = PQexec(conn, line.c_str());
 			if (!res || (PQresultStatus(res) != PGRES_COMMAND_OK && PQresultStatus(res) != PGRES_TUPLES_OK))
 			{
				fprintf(stderr, "%s", PQerrorMessage(conn));
   			fprintf(stderr, "prepared statement %s could not be created. It might be because table for prepared statement does not exist\n", line.c_str());
 			}
			PQclear(res);
		}
	}

	char ***paramValues = (char ***) malloc(sizeof(char**) * numOfInput);
	char **statement_name = (char **) malloc(sizeof(char*) * numOfInput);

	for(int i = 0; i < numOfInput; i ++) {
		paramValues[i] = (char **) malloc(sizeof(char) * numOfParameters);
		for(int j = 0; j < numOfParameters; j ++)
			paramValues[i][j] = (char *) malloc(sizeof(char) * 50000);
		statement_name[i] = (char *) malloc(sizeof(char) * 100);
	}


	//read sql file
  if (myfile.is_open())
  {
		int index = 0;
    while (! myfile.eof() && getline (myfile,line)) {
      stringstream str;
      str << line;
      string word;

      getline(str, word, ';');
      strcpy(statement_name[index], word.c_str());
			for(int j = 0; j < numOfParameters; j ++) {
      	getline(str, word, ';');
      	strcpy(paramValues[index][j], word.c_str());
			}
			index ++;
		}
	}

	res = PQexec(conn, "START TRANSACTION ISOLATION LEVEL READ COMMITTED;");
	PQclear(res);

	for(int i = 0; i < numOfInput; i ++) {
		timeval tim;
		gettimeofday(&tim, NULL);

		res = PQexecPrepared(conn, statement_name[i], numOfParameters, paramValues[i], NULL, NULL, 1);
	
		timeval tim2;
		gettimeofday(&tim2, NULL);

		timeval result;
		timersub(&tim2,&tim,&result);

		wrfile << (result.tv_sec + result.tv_usec/1000000.0) << endl;

		if (!res || (PQresultStatus(res) != PGRES_COMMAND_OK && PQresultStatus(res) != PGRES_TUPLES_OK)) {
			fprintf(stderr, "PROBLEM in insert query in measure, error: %s\n", PQerrorMessage(conn));
			cout << "stmt name: " << statement_name[i] << endl;
			for(int j = 0; j < numOfParameters; j ++) {
				cout << "param[" << j << "]: " << paramValues[i][j] << endl;
			}
			PQclear(res);
			exit_nicely(conn);
		}
		PQclear(res);
	}

	res = PQexec(conn, "END;");
	PQclear(res);

	if(parallel == 0) {
		res = PQexec(conn, "SELECT closeServerConn()");
		if(atoi(PQgetvalue(res, 0, 0)) == 1)
			cout << "server successfully closed" << endl;

		sleep(100);
		PQclear(res);
	}

  PQfinish(conn);

	return 0;	
}
