#include <sys/time.h>
#include <fstream>
#include <stdio.h>
#include "libpq-fe.h"
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <map>
#include <vector>
#include <cassert>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <iterator>

using namespace std;


void
exit_nicely(PGconn *conn)
{
  PQfinish(conn);
  return;
}


int main(int argc, char** argv) {
	string conninfo;
  string query; 
	string line = "";

  PGresult *res;
	PGconn *conn;
  
	string db = argv[1];
	string external_table_name = argv[2];
	int fair = atoi(argv[3]);
	ofstream wrfile (argv[4]);
	int server_id = atoi(argv[5]);

  conninfo = "dbname = " + db;
  conn = PQconnectdb(conninfo.c_str());

	if (PQstatus(conn) == CONNECTION_BAD)
  {
    fprintf(stderr, "Connection to database '%s' failed.\n", db.c_str());
    fprintf(stderr, "%s", PQerrorMessage(conn));
  } 

  int server_id_from_query = -1;

  while(server_id_from_query != server_id) {
    res = PQexec(conn, "SELECT getServerId();");
    server_id_from_query = atoi(PQgetvalue(res, 0, 0));
    sleep(5);
    PQclear(res);
  }

  cerr << "it seems server started" << endl;


/*	query = "SELECT COUNT(*) FROM " + external_table_name + "; SELECT class FROM " + external_table_name + " WHERE id = 25;";
  res = PQexec(conn, query.c_str());
  PQclear(res);
	query = "SELECT COUNT(*) FROM " + external_table_name + "; SELECT COUNT(*) FROM " + external_table_name + " WHERE class = 1;"; 
  res = PQexec(conn, query.c_str());
  PQclear(res);
	query = "SELECT COUNT(*) FROM " + external_table_name + "; SELECT COUNT(*) FROM " + external_table_name + " WHERE eps > 2;";
  res = PQexec(conn, query.c_str());
  PQclear(res);*/

	char *query_char = (char *) malloc(sizeof(char) * 1000);
	query = "SELECT COUNT(*) FROM " + external_table_name + " WHERE class = 1;";
	strcpy(query_char, query.c_str());

	res = PQexec(conn, "START TRANSACTION ISOLATION LEVEL READ COMMITTED;");
	PQclear(res);

	if(fair) {
		for(int i = 0; i < 200; i ++) {
			timeval tim;
			gettimeofday(&tim, NULL);

			res = PQexec(conn, query_char);
	
			timeval tim2;
			gettimeofday(&tim2, NULL);

			timeval result;
			timersub(&tim2,&tim,&result);

			wrfile << (result.tv_sec + result.tv_usec/1000000.0) << endl;

			if (!res || (PQresultStatus(res) != PGRES_COMMAND_OK && PQresultStatus(res) != PGRES_TUPLES_OK)) {
        fprintf(stderr, "error: %s, PROBLEM in insert query in measure\n", PQerrorMessage(conn));
				PQclear(res);
				exit_nicely(conn);
			}
			PQclear(res);
		}
	}
	else {
		for(int i = 0; i < 200; i ++) {
      timeval tim;
      gettimeofday(&tim, NULL);

      res = PQexec(conn, "SELECT getView()");
  
      timeval tim2;
      gettimeofday(&tim2, NULL);

      timeval result;
      timersub(&tim2,&tim,&result);

      wrfile << (result.tv_sec + result.tv_usec/1000000.0) << endl;

      if (!res || (PQresultStatus(res) != PGRES_COMMAND_OK && PQresultStatus(res) != PGRES_TUPLES_OK)) {
        fprintf(stderr, "error: %s, PROBLEM in insert query in measure\n", PQerrorMessage(conn));
        PQclear(res);
        exit_nicely(conn);
      }
      PQclear(res);
		}
	}

	res = PQexec(conn, "END;");
	PQclear(res);

  res = PQexec(conn, "SELECT closeServerConn()");
  if(atoi(PQgetvalue(res, 0, 0)) == 1)
    cout << "server successfully closed" << endl;

  sleep(100);
  PQclear(res);

  PQfinish(conn);

	return 0;	
}
