dataset_name=$1
mm_hazy_version=$2
strategy_algorithm=$3
resOpt=1000
dim=$4
initial_resort_time=$5
dbname=VLDB11_Exp
tao_val=0.001
m_factor=$6
ratio=1
entity_table_name=sm_test_entity_table_name
dense_feature=$7
logging=$8
run_id=$9
model1_path=${10}
model2_path=${11}
fair_se_eager=${12}
buffer_size=0
useepsmap=0
if [ $mm_hazy_version == 2 ]
then
  buffer_size=${13}
  useepsmap=${14}
fi


server_id=$(date +%s)

external_table_name="sm_test_external_table"
FLAGS="";

if [ $mm_hazy_version -eq 1 ];
then
  FLAGS="$FLAGS --mainmemory"
elif [ $mm_hazy_version -eq 2 ];
then
  FLAGS="$FLAGS --hybrid --buf_size $buffer_size"
  if [ $useepsmap -eq 1 ]
  then
    FLAGS="$FLAGS --useepsmap"
  fi
fi

if [ $dense_feature == 1 ]
then
  FLAGS="$FLAGS --dense"
fi


FLAGS="$FLAGS --strategy $strategy_algorithm --reservoir $resOpt --resort_time $initial_resort_time --tao_val $tao_val --alpha_ratio $ratio --model1 $model1_path --model2 $model2_path"

g++ -g -O3 -fPIC -Wall -I /scratch/koc/Programs/postgresql/include -L/scratch/koc/Programs/postgresql/lib -o scripts/measure_time_count -lpq -lz -lm scripts/MeasureTime_getCount.cpp

vector_type="";

if [ $dense_feature == 1 ]
then
	vector_type="FLOAT8[]";
else
	vector_type="pair[]";
fi

psql $dbname -c "DROP TABLE IF EXISTS sm_test_entity_table_name CASCADE; CREATE TABLE sm_test_entity_table_name(id int, feature_vector $vector_type); COPY sm_test_entity_table_name FROM '/scratch/koc/VLDB11_Experiments/raw_data/$dataset_name/new.$dataset_name.data.on_disk_update' DELIMITER ';'";
psql $dbname -c "CREATE INDEX ent_ind ON sm_test_entity_table_name USING hash(id);";
psql $dbname -c "DROP TABLE IF EXISTS large_update_pos; CREATE TABLE large_update_pos(id int, name text);";
psql $dbname -c "DROP TABLE IF EXISTS large_update_neg; CREATE TABLE large_update_neg(id int, name text);";
psql $dbname -c "DROP TRIGGER IF EXISTS pos_trigger ON large_update_pos; CREATE TRIGGER pos_trigger AFTER INSERT OR UPDATE OR DELETE ON large_update_pos FOR EACH ROW EXECUTE PROCEDURE update_trig();";
psql $dbname -c "DROP TRIGGER IF EXISTS neg_trigger ON large_update_neg; CREATE TRIGGER neg_trigger AFTER INSERT OR UPDATE OR DELETE ON large_update_neg FOR EACH ROW EXECUTE PROCEDURE update_trig();";

if [ $logging == 1 ]
then
  rm -rf ../experiments/read_count_experiments/$dataset_name/$dataset_name.count_read.mm.$mm_hazy_version.strategy.$strategy_algorithm.run.$run_id.fair.$fair_se_eager.log
  echo "exec/hazy_log $FLAGS $dim $dbname $m_factor $entity_table_name $server_id"
  exec/hazy_log $FLAGS $dim $dbname $m_factor $entity_table_name $server_id >> ../experiments/read_count_experiments/$dataset_name/$dataset_name.count_read.mm.$mm_hazy_version.strategy.$strategy_algorithm.run.$run_id.fair.$fair_se_eager.log &
else
  echo "exec/hazy_main $FLAGS $dim $dbname $m_factor $entity_table_name $server_id"
  exec/hazy_main $FLAGS $dim $dbname $m_factor $entity_table_name $server_id &
fi

query_input="";

if [ $mm_hazy_version == 1 ]
then
	query_input=/scratch/koc/VLDB11_Experiments/raw_data/$dataset_name/new.$dataset_name.data.single_read_queries
elif [ $mm_hazy_version == 1 ]
then
	query_input=/scratch/koc/VLDB11_Experiments/raw_data/$dataset_name/new.$dataset_name.data.single_read_queries
else
	#lazy
	if [ $strategy_algorithm == 0 -o $strategy_algorithm == 2 ]
	then
		query_input=/scratch/koc/VLDB11_Experiments/raw_data/$dataset_name/new.$dataset_name.data.single_read_queries_lazy
	else
		if [ $fair_se_eager == 0 ]
		then
			query_input=/scratch/koc/VLDB11_Experiments/raw_data/$dataset_name/new.$dataset_name.data.single_read_queries
		else
			query_input=/scratch/koc/VLDB11_Experiments/raw_data/$dataset_name/new.$dataset_name.data.single_read_queries_eager_unfair
		fi
	fi
fi

echo "starting experiment"
if [ $logging == 1 ]
then
	echo "count script is being called"
  scripts/measure_time_count $dbname $external_table_name $fair_se_eager ../experiments/read_count_experiments/$dataset_name/$dataset_name.count_read.mm.$mm_hazy_version.strategy.$strategy_algorithm.run.$run_id.fair.$fair_se_eager.log.mode $server_id
else
  scripts/measure_time_count $dbname $external_table_name $fair_se_eager ../experiments/read_count_experiments/$dataset_name/$dataset_name.count_read.mm.$mm_hazy_version.strategy.$strategy_algorithm.run.$run_id.fair.$fair_se_eager $server_id
fi



