#include "model.h"

///Sets model from given string in svm format
// String is in crazy french format.
/**
 * Parses given input stream to create a model
 */
std::istream&
operator>>(std::istream &f, model &m) {
  f >> m.w >> m.bias >> m.wscale >> m.t >> m.dim;
  LOGGING_ONLY(std::cout << m.w << " " << m.bias << " " << m.wscale << " " << m.t << " " << m.dim << std::endl;);
  return f;
}
/**
 * Writes model to the output stream
 */
std::ostream& 
operator<<(std::ostream &f, const model &m) {    
  f << m.w << m.bias << " " << m.wscale << " " << m.t << " " << m.dim;
  return f;
}


// Useful for debugging
model 
round_trip_model(const model &m_in) {  
  std::ostringstream ostr;
  ostr << m_in;
  std::istringstream istr(ostr.str());
  model m_out;
  istr >> m_out;      
  return m_out;
}
