#ifndef PARSE_CONF_FILE_H
#define PARSE_CONF_FILE_H

#include "globals.h"
#include <stdlib.h>
#include <string.h>

char* retrieve_hazy_conf_file_path();
char* retrieve_hazy_dirs_path();

#ifdef __cplusplus
#include <string>
#include <iostream>
#include <sstream>
#include <fstream>
#include "hazy_model.h"

#define SUCCESSFUL_PARSE 0
#define POSTGRES_PATH_PARSE_PROBLEM -1
#define DBNAME_PARSE_PROBLEM -2
#define SM_PARSE_PROBLEM -3
#define USEEPS_PARSE_PROBLEM -4
#define HAZY_ST_PARSE_PROBLEM -5
#define RESERVOIR_SIZE_PARSE_PROBLEM -6
#define BUFFER_SIZE_PARSE_PROBLEM -7
#define FILE_NOT_FOUND -8
#define POSTGRES_LINE_NOT_FOUND -9
#define DBNAME_LINE_NOT_FOUND -10
#define SM_PARSE_LINE_NOT_FOUND -11
#define USEEPS_LINE_NOT_FOUND -12
#define HAZY_ST_LINE_NOT_FOUND -13
#define RESERVOIR_LINE_NOT_FOUND -14
#define BUFFER_SIZE_LINE_NOT_FOUND -15

int parse_dbname_from_conf_file(std::string conf_file_path, std::string &db_name);
int parse_postgres_path_from_conf_file(std::string conf_file_path, std::string &postgres_path);
int parse_hazy_settings(std::string conf_file_path, enum storage_manager_type &sm, int &useepsmap, 
			 hazy_model::strategy &hazy_strategy, int &reservoir_size, int &buffer_size);
void handle_success_code(int parse_success_code);

#endif

#endif
