/**
 * \file timer.h
 */
#ifndef _timer_h
#define _timer_h
#include <sys/time.h>
#include "globals.h"

/**
 * Class for measureing elapsed time for code segments
 */
class Timer {
 private:
  ///boolean allows it to start 
  bool bStart;
  ///start & stop time
  timeval _start,_stop;
 public:
  /**
   * Default constructor
   */
  Timer(); 
  /**
   * Constructor that starts timer when called
   * \param[in] bStart when this is true, then time is started when constructor is called
   */
  Timer(bool bStart);
  /**
   * Starts timer
   */
  void start();
  /**
   * Stops timer and returns elapsed time
   * \return elapsed time
   */
  double stop();
  /**
   * Returns elapsed time
   * \return elapsed time
   */
  double getElapsedTime(); 
};
#endif
